<template>
    <div class="linechart" :id="id" style="width: 100%; height: 100%"></div>
</template>

<script>
import tool from "./common/tool.js";

export default {
    name: "lineChartCarsimB", // carsim-折线图
    mixins: [tool],
    props: {
        id: {
            default: "lineChartCarsimB",
            type: String,
        },
        dataList: {
            default: function () {
                return [];
            },
            type: Array,
        },
        columns: {
            default: function () {
                return [];
            },
            type: Array,
        },
        xName: {
            default: "",
            type: String,
        },
        yName: {
            default: "",
            type: String,
        },
    },

    data() {
        return {
            charts: "",
        };
    },

    watch: {
        dataList: {
            handler(val) {
                if (val.length > 0) {
                    this.initStateList();
                }
            },
            deep: true,
        },
    },

    methods: {
        initStateList() {
            let array = this.dataList;

            for (let index = 0; index < array.length; index++) {
                const element = array[index];

                let flag = Object.values(element).some((i) => i === "");

                if (flag) {
                    this.charts.clear();
                    this.charts.setOption(this.option1);
                    return;
                }
            }

            // if (!this.isSorted(array.map((i) => i.x))) {
            //     this.$message.error("X轴的坐标应逐渐增大");
            //     this.charts.clear();
            //     this.charts.setOption(this.option1);
            //     return;
            // }

            // let props = ["x", "y"];

            // let xData = [];
            // let yData = [];

            /* props.forEach((j) => {
                let arr = [];
                array.forEach((i) => {
                    let a = i[j] || 0;
                    if (j === "x") {
                        xData.push(a);
                    } else {
                        arr.push(a);
                    }
                });

                if (j != "x") yData.push(arr);
            }); */

            let brr = [];

            array.forEach((i) => {
                brr.push([i.x, i.y]);
            });

            let series = [];

            series[0] = {
                data: brr,
                type: "line",
                name: "Y Axis",
                smooth: false,
                symbol: "circle",
                symbolSize: 6,
                lineStyle: {
                    normal: {
                        width: 1.5,
                        color: this.themeColor,
                    },
                },
                itemStyle: {
                    normal: {
                        color: this.themeColor,
                    },
                },
            };

            /* yData.forEach((i, index) => {
                series.push({
                    name: "数据",
                    data: i,
                    type: "line",
                    smooth: false,
                    symbol: "circle",
                    symbolSize: 6,
                    lineStyle: {
                        normal: {
                            width: 1.5,
                            color: this.themeColor,
                        },
                    },
                    itemStyle: {
                        normal: {
                            color: this.themeColor,
                        },
                    },
                });
            }); */

            let option = {
                title: {
                    text: "暂无数据",
                    show: series.length === 0,
                    left: "center",
                    top: "center",
                },
                tooltip: {
                    //提示框，可以在全局也可以在
                    trigger: "item", //提示框的样式
                    formatter: "{b}: {c}",
                    color: "#000", //提示框的背景色
                    textStyle: {
                        //提示的字体样式
                        color: "#ffffff",
                    },
                    confine: true,
                },
                xAxis: {
                    name: this.xName,
                    type: "value",
                    boundaryGap: false,
                    axisTick: { inside: true },
                    nameLocation: "center",
                    nameGap: 30,
                    // data: xData,
                },
                yAxis: {
                    name: this.yName,
                    type: "value",
                    axisTick: { inside: true },
                    scale: true,
                },
                legend: {},
                series,
                grid: {
                    top: "60px",
                    left: "30px",
                    right: "30px",
                    bottom: "10%",
                    containLabel: true,
                },
            };
            this.charts.setOption(option);
        },
    },
};
</script>

<style lang='less' scoped>
.linechart {
    margin: 0 auto;
    overflow: hidden;
}
</style>